<?php
// include client class
include_once(dirname(__FILE__).'/eoleclient.php');
// include client class
include_once(dirname(__FILE__).'/CAS.php');

class EolephpCAS extends phpCAS
{
    /*
     * FONCTIONS EOLE
     */
    public static function EoleLogoutRequests($check_client=true, $allowed_clients=false){
            /*
             * Fonction gérant les requêtes de logout centralisées provenant du serveur sso
             * @check_client : should the cas server be checked
             * @allowed_clients : array of trusted clients
             */
            global $PHPCAS_CLIENT;
            if ( !is_object($PHPCAS_CLIENT) ) {
                phpCAS::error('this method should not be called before '.__CLASS__.'::client() or '.__CLASS__.'::proxy()');
            }
            return($PHPCAS_CLIENT->EoleLogoutRequests($check_client, $allowed_clients));
    }
    /*
     * FONCTIONS ECRASEES
     */

    public static function client($server_version,
        $server_hostname,
        $server_port,
        $server_uri,
        $start_session = true)
    {
        /*
         * Fonction d'initialisation du client,
         * écrasée pour appeler utiliser le client eolecasclient au lieu du client classique
         */
        global $PHPCAS_CLIENT, $PHPCAS_INIT_CALL;
        phpCAS::traceBegin();
        if ( is_object($PHPCAS_CLIENT) ) {
            phpCAS::error($PHPCAS_INIT_CALL['method'].'() has already been called (at '.$PHPCAS_INIT_CALL['file'].':'.$PHPCAS_INIT_CALL['line'].')');
        }
        if ( gettype($server_version) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_version (should be `string\')');
        }
        if ( gettype($server_hostname) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_hostname (should be `string\')');
        }
        if ( gettype($server_port) != 'integer' ) {
            phpCAS::error('type mismatched for parameter $server_port (should be `integer\')');
        }
        if ( gettype($server_uri) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_uri (should be `string\')');
        }
        // store where the initializer is called from
        $dbg = phpCAS::backtrace();
        $PHPCAS_INIT_CALL = array('done' => TRUE,
            'file' => $dbg[0]['file'],
            'line' => $dbg[0]['line'],
            'method' => __CLASS__.'::'.__FUNCTION__);
        // initialize the global object $PHPCAS_CLIENT
        $PHPCAS_CLIENT = new EoleCASClient($server_version,FALSE/*proxy*/,$server_hostname,$server_port,$server_uri,$start_session);
        phpCAS::traceEnd();
    }
    public static function proxy($server_version,
        $server_hostname,
        $server_port,
        $server_uri,
        $start_session = true)
    {
        /*
         * Fonction d'initialisation du proxy,
         * écrasée pour appeler utiliser le client eolecasclient au lieu du client classique
         */
        global $PHPCAS_CLIENT, $PHPCAS_INIT_CALL;
        phpCAS::traceBegin();
        if ( is_object($PHPCAS_CLIENT) ) {
            phpCAS::error($PHPCAS_INIT_CALL['method'].'() has already been called (at '.$PHPCAS_INIT_CALL['file'].':'.$PHPCAS_INIT_CALL['line'].')');
        }
        if ( gettype($server_version) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_version (should be `string\')');
        }
        if ( gettype($server_hostname) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_hostname (should be `string\')');
        }
        if ( gettype($server_port) != 'integer' ) {
            phpCAS::error('type mismatched for parameter $server_port (should be `integer\')');
        }
        if ( gettype($server_uri) != 'string' ) {
            phpCAS::error('type mismatched for parameter $server_uri (should be `string\')');
        }
        // store where the initializer is called from
        $dbg = phpCAS::backtrace();
        $PHPCAS_INIT_CALL = array('done' => TRUE,
            'file' => $dbg[0]['file'],
            'line' => $dbg[0]['line'],
            'method' => __CLASS__.'::'.__FUNCTION__);
        // initialize the global object $PHPCAS_CLIENT
        $PHPCAS_CLIENT = new EoleCASClient($server_version,TRUE/*proxy*/,$server_hostname,$server_port,$server_uri,$start_session);
        phpCAS::traceEnd();
    }
    /**
     * HACK pour la gestion des propriétés utilisateurs aux modèles CAS
     *
     * Methode de renvoie des details utilisateurs
     ***/
    public static function getDetails()
    {
        /*
         * Renvoie les détails utilisateurs
         */
        global $PHPCAS_CLIENT, $PHPCAS_AUTH_CHECK_CALL;
        if ( !is_object($PHPCAS_CLIENT) ) {
            phpCAS::error('this method should not be called before '.__CLASS__.'::client() or '.__CLASS__.'::proxy()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['done'] ) {
            phpCAS::error('this method should only be called after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['result'] ) {
            phpCAS::error('authentication was checked (by '.$PHPCAS_AUTH_CHECK_CALL['method'].'() at '.$PHPCAS_AUTH_CHECK_CALL['file'].':'.$PHPCAS_AUTH_CHECK_CALL['line'].') but the method returned FALSE');
        }
        return $PHPCAS_CLIENT->getDetails();
    }
    public static function getCasXML()
    {
        /*
         * Renvoie le xml cas reçu depuis le serveur
         */
        global $PHPCAS_CLIENT, $PHPCAS_AUTH_CHECK_CALL;
        if ( !is_object($PHPCAS_CLIENT) ) {
            phpCAS::error('this method should not be called before '.__CLASS__.'::client() or '.__CLASS__.'::proxy()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['done'] ) {
            phpCAS::error('this method should only be called after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['result'] ) {
            phpCAS::error('authentication was checked (by '.$PHPCAS_AUTH_CHECK_CALL['method'].'() at '.$PHPCAS_AUTH_CHECK_CALL['file'].':'.$PHPCAS_AUTH_CHECK_CALL['line'].') but the method returned FALSE');
        }
        return $PHPCAS_CLIENT->getCasXML();
    }
    public static function hasPGT(){
        /*
         * Fonction hasPGT rajoutée pour confort
         */
        global $PHPCAS_CLIENT, $PHPCAS_AUTH_CHECK_CALL;
        if ( !is_object($PHPCAS_CLIENT) ) {
            phpCAS::error('this method should not be called before '.__CLASS__.'::client() or '.__CLASS__.'::proxy()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['done'] ) {
            phpCAS::error('this method should only be called after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
        }
        if ( !$PHPCAS_AUTH_CHECK_CALL['result'] ) {
            phpCAS::error('authentication was checked (by '.$PHPCAS_AUTH_CHECK_CALL['method'].'() at '.$PHPCAS_AUTH_CHECK_CALL['file'].':'.$PHPCAS_AUTH_CHECK_CALL['line'].') but the method returned FALSE');
        }
        return $PHPCAS_CLIENT->hasPGT();
    }
}
?>
